package com.miya.manning.framework.request;

import net.sf.json.JSONObject;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.util.EntityUtils;

import java.io.IOException;
import java.util.Iterator;
import java.util.Map;

/**
 * @ProjectName: MY_INTERFACE_TEST
 * @Package: com.miya.interfacetest.framework.request
 * @ClassName: HTTPPut
 * @Description: java类作用描述
 * @Author: 唐奇良
 * @CreateDate: 2019/1/21 下午5:41
 * @UpdateUser: 更新者
 * @UpdateDate: 2019/1/21 下午5:41
 */
public class HTTPPut {

    public static String httpPut(String url, JSONObject jsonParam) throws IOException {
        HttpClient client = HttpClientBuilder.create().build();
        HttpPut put = new HttpPut(url);
        put.setHeader("Content-Type","application/json");
        put.addHeader("Accept", "application/json");
        StringEntity params =new StringEntity(jsonParam.toString(), "utf-8");
        put.setEntity(params);
        HttpResponse response = client.execute(put);
        HttpEntity httpEntity = response.getEntity();
        String result = EntityUtils.toString(httpEntity, "UTF-8");
        return result;
    }


    public static String httpPut(String url,  Map<String,String> httpHeaderMap) throws IOException {
        HttpClient client = HttpClientBuilder.create().build();
        HttpPut put = new HttpPut(url);
        Iterator headerIterator = httpHeaderMap.entrySet().iterator(); //循环增加header
        while (headerIterator.hasNext()) {
            Map.Entry<String, String> elem = (Map.Entry<String, String>) headerIterator.next();
            put.addHeader(elem.getKey(), elem.getValue());
        }
        HttpResponse response = client.execute(put);
        HttpEntity httpEntity = response.getEntity();
        String result = EntityUtils.toString(httpEntity, "UTF-8");
        return result;
    }

}