package com.miya.manning.framework.util;

import java.util.HashMap;
import java.util.Map;
import java.util.regex.Pattern;

/**
 * @ProjectName: MY_INTERFACE_TEST
 * @Package: com.miya.interfacetest.framework.util
 * @ClassName: ParamsBuilt
 * @Description: 此函数的作用是构建一个包含公共参数的的params格式文件
 * @Author: 唐奇良
 * @CreateDate: 2019/1/22 下午2:57
 * @UpdateUser: 更新者
 * @UpdateDate: 2019/1/22 下午2:57
 */
public class ParamsBuilt {

    private static String region_id = PropertiesHandle.readValue("region_id");
    private static String uuid = PropertiesHandle.readValue("uuid");
    private static String udid = PropertiesHandle.readValue("udid");
    private static String android_iOS = PropertiesHandle.readValue("android_iOS");
    private static String version = PropertiesHandle.readValue("version");
    private static String time = PropertiesHandle.readValue("time");
    private static String security = PropertiesHandle.readValue("security");

    public static Map<String, String> params_built() {
        Map<String, String> params = new HashMap<String, String>();
        params.put("region_id", region_id);
        params.put("uuid", uuid);
        params.put("udid", udid);
        params.put("android_iOS", android_iOS);
        params.put("version", version);
        params.put("time", time);
        params.put("security", security);
        return params;
    }


    public static String params_replace(String params, Map<String, Integer> int_var_map, Map<String, String> string_var_map ) {
        if(params != null){
            if (int_var_map.size() != 0) {
                /*for (Map.Entry<String, Integer> entry : int_var_map.entrySet()) {
                    params = params.replaceAll(entry.getKey(), String.valueOf(entry.getValue()));
                    if(params.contains(Symbol.Type_plus.getSymbol())){
                        BigDecimal sum = BigDecimal.valueOf(0);
                        String[] every = params.split(Symbol.Type_plus.getSymbol());//根据加号拆分每项
                        for(String addend : every){
                            sum =  sum.add(BigDecimal.valueOf(Integer.parseInt(addend)));
                            sum.setScale(2,BigDecimal.ROUND_HALF_UP);//按照四舍五入取两位小数处理
                        }
                        params = String.valueOf(sum);
                    }
                    if(params.contains(Symbol.Type_minus.getSymbol())){
                        BigDecimal sum = BigDecimal.valueOf(0);
                        String[] every = params.split(Symbol.Type_minus.getSymbol());//根据减号拆分每项
                        for(String minuend :every){
                            sum = sum.subtract(BigDecimal.valueOf(Integer.parseInt(minuend)));
                            sum.setScale(2,BigDecimal.ROUND_HALF_UP);//按照四舍五入取两位小数处理
                        }
                        params = String.valueOf(sum);
                    }
                    if(params.contains(Symbol.Type_multi.getSymbol())){
                        BigDecimal sum = BigDecimal.valueOf(1);
                        String[] every = params.split(Symbol.Type_multi.getSymbol());//根据乘号拆分每项
                        for(String multiplicand :every){
                            sum = sum.multiply(BigDecimal.valueOf(Integer.parseInt(multiplicand)));
                            sum.setScale(2,BigDecimal.ROUND_HALF_UP);//按照四舍五入取两位小数处理
                        }
                        params = String.valueOf(sum);
                    }
                    if(params.contains(Symbol.Type_divide.getSymbol())){
                        String[] every = params.split(Symbol.Type_divide.getSymbol());//根据除号拆分每项
                        BigDecimal sum = BigDecimal.valueOf(Integer.parseInt(every[0]));
                        for(int i = 1 ; i< every.length; i ++){
                            sum = sum.divide(BigDecimal.valueOf(Integer.parseInt(every[i])));
                            sum.setScale(2,BigDecimal.ROUND_HALF_UP);
                        }
                        params = String.valueOf(sum);
                    }
                }*/
            }
            if (string_var_map.size() != 0) {
                for (Map.Entry<String, String> entry : string_var_map.entrySet()) {
                    params = params.replaceAll(entry.getKey(), entry.getValue());
                }
            }
        }

        return params;
    }

    /***
     *
     * @param params 待替换的参数
     * @param int_var_map int变量集
     * @param string_var_map string变量集
     * @param res_map 响应变量集
     * @return
     */
    public static String params_replace(String params, Map<String, Integer> int_var_map, Map<String, String> string_var_map ,Map<String,String> res_map ) {
        if(params != null){
            if (int_var_map.size() != 0) {
                for (Map.Entry<String, Integer> entry : int_var_map.entrySet()) {
                    params = params.replaceAll(entry.getKey(), String.valueOf(entry.getValue()));
                    /*if(params.contains(Symbol.Type_plus.getSymbol())){
                        BigDecimal sum = BigDecimal.valueOf(0);
                        String[] every = params.split(Symbol.Type_plus.getSymbol());//根据加号拆分每项
                        for(String addend : every){
                            sum =  sum.add(BigDecimal.valueOf(Integer.parseInt(addend)));
                            sum.setScale(2,BigDecimal.ROUND_HALF_UP);//按照四舍五入取两位小数处理
                        }
                        params = String.valueOf(sum);
                    }
                    if(params.contains(Symbol.Type_minus.getSymbol())){
                        BigDecimal sum = BigDecimal.valueOf(0);
                        String[] every = params.split(Symbol.Type_minus.getSymbol());//根据减号拆分每项
                        for(String minuend :every){
                            sum = sum.subtract(BigDecimal.valueOf(Integer.parseInt(minuend)));
                            sum.setScale(2,BigDecimal.ROUND_HALF_UP);//按照四舍五入取两位小数处理
                        }
                        params = String.valueOf(sum);
                    }
                    if(params.contains(Symbol.Type_multi.getSymbol())){
                        BigDecimal sum = BigDecimal.valueOf(1);
                        String[] every = params.split("\\*");//根据乘号拆分每项
                        for(String multiplicand :every){
                            sum = sum.multiply(BigDecimal.valueOf(Integer.parseInt(multiplicand)));
                            sum.setScale(2,BigDecimal.ROUND_HALF_UP);//按照四舍五入取两位小数处理
                        }
                        params = String.valueOf(sum);
                    }
                    if(params.contains(Symbol.Type_divide.getSymbol())){
                        String[] every = params.split(Symbol.Type_divide.getSymbol());//根据除号拆分每项
                        BigDecimal sum = BigDecimal.valueOf(Integer.parseInt(every[0]));
                        for(int i = 1 ; i< every.length; i ++){
                            sum = sum.divide(BigDecimal.valueOf(Integer.parseInt(every[i])));
                            sum.setScale(2,BigDecimal.ROUND_HALF_UP);
                        }
                        params = String.valueOf(sum);
                    }*/
                }
            }
            if (string_var_map.size() != 0) {
                for (Map.Entry<String, String> entry : string_var_map.entrySet()) {
                    params = params.replaceAll(entry.getKey(), entry.getValue());
                }
            }
            //这里分割可能会存在bug
            if(res_map.size() != 0){
                //get请求参数
                if(params.contains("=")){
                    String[] subs =  params.split("&");
                    for(String str: subs){
                        String[] sub =  str.split("=");
                        if(sub.length>1){//防止get请求中有参数是空
                            //去除掉参数中的引号
                            String after = sub[1].replaceAll("\"", "");
                            if(res_map.containsKey(after)){
                                params = params.replaceAll(after,res_map.get(after));
                            }
                        }
                    }
                }
                //post请求参数
                if(params.contains(":")){
                    String[] subs = params.split(",");
                    for(String str : subs){
                        String[] sub = str.split(":");
                        if(sub.length>1){
                            String after = sub[sub.length-1].replaceAll("\"", "");
                            after = after.replaceAll("}", "");
                            //array里的最后一个对象还会带],也需要去掉
                            after = after.replaceAll("]", "");
                            if(res_map.containsKey(after)){
                                params = params.replaceAll(after, res_map.get(after));
                            }
                        }
                    }
                }
            }
        }
        //对于参数中的值包含运算符的,进行运算后再返回


        return params;
    }




    public static String sql_replace(String sql, Map<String, Integer> int_var_map, Map<String, String> string_var_map ,Map<String,String> res_map ) {
        if(sql != null){
            if (int_var_map.size() != 0) {
                for (Map.Entry<String, Integer> entry : int_var_map.entrySet()) {
                    sql = sql.replaceAll(entry.getKey(), String.valueOf(entry.getValue()));
                }
            }
            if (string_var_map.size() != 0) {
                for (Map.Entry<String, String> entry : string_var_map.entrySet()) {
                    sql = sql.replaceAll(entry.getKey(), entry.getValue());
                }
            }
            if(res_map.size() != 0){
                //
                String[] subs =  sql.split(" ");
                for(String str: subs){
                        String after = str.replaceAll("\"", "");
                        if(res_map.containsKey(after)){
                            sql = sql.replaceAll(after,res_map.get(after));
                        }
                        }
                    }
                }
        return sql;
    }






    public static void main(String[] args) {
        String  a = "1.0";
        Integer.parseInt(a);
    }
}
