package com.miya.manning.framework.util;

import com.miya.manning.framework.request.HTTPGet;
import com.miya.manning.framework.request.HTTPPost;
import com.miya.manning.framework.request.HTTPPut;
import com.miya.manning.vo.testcase.TestCase;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.apache.log4j.Logger;

import java.util.Map;

public class RequestUtil {
    /***
     *
     * @param testCase 用例对象
     * @param new_params 替换变量后的请求参数
     * @param url 请求地址
     * @param httpheadermap 请求头
     * @param logger 日志实例
     * @param builder
     * @return 应答信息
     * @throws Exception
     */
    public static String doRequest(TestCase testCase , String new_params , StringBuffer url, Map<String,String> httpheadermap , Logger logger , StringBuilder builder ) throws Exception{
        if("get".equals(testCase.getMethod_type())){
            if(new_params != null ){
                url.append(new_params);
            }
            String new_url = url.toString();
            logger.info("url为:" + new_url);
            String result = HTTPGet.httpGet(new_url, httpheadermap);
            builder.append(result);
            logger.info("收到的应答为:" + result);
        }else if("post".equals(testCase.getMethod_type())){
            if(testCase.isIs_uploadfile()){
                //文件流
                String result = HTTPPost.httpuploadfile(url.toString(), testCase.getPath(),httpheadermap);
                builder.append(result);
                logger.info(result);
            }else {
                //正常传参
                logger.info(url.toString());
                if(new_params.startsWith("[")){
                    JSONArray Req = JsonTransfer.ToJsonArray(new_params);
                    System.out.println(Req);
                    String result = HTTPPost.httpPost(url.toString(),Req,httpheadermap);
                    builder.append(result);
                    logger.info(result);
                }
                else if (new_params.startsWith("{")){
                    JSONObject Req = JsonTransfer.ToJsonObject(new_params);
                    System.out.println(Req);
                    String result = HTTPPost.httpPost(url.toString(),Req,httpheadermap);
                    builder.append(result);
                    logger.info(result);
                }
            }

        }
        else if("put".equals(testCase.getMethod_type())){
            if(new_params != null ){
                url.append(new_params);
            }
            String new_url = url.toString();
            logger.info("url为:" + new_url);
            String result = HTTPPut.httpPut(new_url, httpheadermap);
            builder.append(result);
            logger.info("收到的应答为:" + result);
        }
        return builder.toString();
    }
}
