package com.miya.manning.framework.util.dbutil;

import com.miya.manning.framework.util.PropertiesHandle;

import java.sql.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ProjectName: MY_INTERFACE_TEST
 * @Package: com.miya.interfacetest.framework.util.dbutil
 * @ClassName: MysqlUtil
 * @Description: java类作用描述
 * @Author: 唐奇良
 * @CreateDate: 2019/1/22 下午7:06
 * @UpdateUser: 更新者
 * @UpdateDate: 2019/1/22 下午7:06
 */
public class MysqlUtil {

    //private static String sql_host = PropertiesHandle.readValue(StringUtil.dbconfig.sql_host, "sql_host");
    private static String file_path = "src/main/resources/db.properties";
    private static String sql_host = PropertiesHandle.readValue(file_path, "sql_host");
    private static String sql_username = PropertiesHandle.readValue(file_path, "sql_username");
    private static String sql_pwd = PropertiesHandle.readValue(file_path, "sql_pwd");
    //public String url = "jdbc:mysql://";
    private static String name = "com.mysql.jdbc.Driver";

    public static Connection conn = null; //定义一个MYSQL链接对象
    public static Statement stmt = null; //创建声明
    public static ResultSet rs = null;

    //public MysqlUtil(String host, String port, String instanceName, String username, String password) {
    //    url = url + host + ":" + port + "/" + instanceName + "?" + "user=" + username + "&password=" + password + "&useUnicode=true&characterEncoding=UTF8";
    //}

    public ResultSet ExecuteSelectSQL(String sql) {
        try {
            Class.forName(name).newInstance(); //MYSQL驱动
            conn = DriverManager.getConnection(sql_host, sql_username, sql_pwd);//获取连接
            stmt = conn.createStatement();//准备执行语句
            rs = stmt.executeQuery(sql);
            /**
            String name="";
            while (rs.next()) {
                name =rs.getString("spell");//获取spell字段的值
            }
             **/
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            try {
                if (rs != null) {
                    rs.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
            try {
                if (stmt != null) {
                    stmt.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
            try {
                if (conn != null) {
                    conn.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
        return rs;
        //return name;
}

    public static int ExecuteSingleUpdateSQL(String sql ,String databasename) {
        int result = 0;
        try {
            Class.forName(name).newInstance(); //MYSQL驱动
            if(!databasename.isEmpty()){
                //先找最后一个/出现的位置
                int first_index = sql_host.lastIndexOf("/");
                //再找?出现的位置,中间这部分就是需要替换的数据库名
                int last_index = sql_host.lastIndexOf("?");
                String sub_host1 = sql_host.substring(0,first_index+1);
                String sub_host2 = sql_host.substring(last_index);
                String final_host = sub_host1 + databasename + sub_host2;
                conn = DriverManager.getConnection(final_host, sql_username, sql_pwd);
            }
            else{
                conn = DriverManager.getConnection(sql_host, sql_username, sql_pwd);//获取连接
            }
            stmt = conn.createStatement();//准备执行语句
            result = stmt.executeUpdate(sql);
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            try {
                if (stmt != null) {
                    stmt.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
            try {
                if (conn != null) {
                    conn.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
        return result;
    }

    public void close() {
        try {
            this.conn.close();
            this.stmt.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public static List convertList(ResultSet rs) throws SQLException {

        List list = new ArrayList();

        ResultSetMetaData md = rs.getMetaData();

        int columnCount = md.getColumnCount();

        while (rs.next()) {

            Map rowData = new HashMap<String , Object>();

            for (int i = 1; i <= columnCount; i++) {

                rowData.put(md.getColumnName(i), rs.getObject(i));

            }

            list.add(rowData);

        }

        return list;

    }

    public static List ExecSelectSQL(String sql,String databasename) {
        List res = null;

        try {
            Class.forName(name).newInstance(); //MYSQL驱动
            if(!databasename.isEmpty()){
                //先找最后一个/出现的位置
                int first_index = sql_host.lastIndexOf("/");
                //再找?出现的位置,中间这部分就是需要替换的数据库名
                int last_index = sql_host.lastIndexOf("?");
                String sub_host1 = sql_host.substring(0,first_index+1);
                String sub_host2 = sql_host.substring(last_index);
                String final_host = sub_host1 + databasename + sub_host2;
                conn = DriverManager.getConnection(final_host, sql_username, sql_pwd);
            }
            else{
                conn = DriverManager.getConnection(sql_host, sql_username, sql_pwd);//获取连接
            }

            stmt = conn.createStatement();//准备执行语句
            rs = stmt.executeQuery(sql);
            res = convertList(rs);
            /**
             String name="";
             while (rs.next()) {
             name =rs.getString("spell");//获取spell字段的值
             }
             **/
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (rs != null) {
                    rs.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
            try {
                if (stmt != null) {
                    stmt.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
            try {
                if (conn != null) {
                    conn.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
        return res;
    }

  /*  public static void main(String[] args) throws SQLException {
        String id = "2210";
        MysqlUtil mysqlUtil = new MysqlUtil();
        //MysqlUtil mysqlUtil = new MysqlUtil("mysqlif.ops.com","3306","tubobo_merchant","chenyl","chenyl");
//        String sql = "SELECT * from sys_message where phone = '"+phone+"' ORDER BY create_date desc";
        String sql = "select is_top from theme_subject where id =id";
        ResultSet rs =mysqlUtil.ExecuteSelectSQL(sql);
        rs.next();
        String is_top = rs.getString("is_top");
        System.out.println("is_top="+is_top);
//        try {
//          if(rs.first()){
//                 String code = rs.getString("content");
//                String codeSms = code.substring(25,code.length()-2);
//                System.out.println("code="+code+"sms="+codeSms);
//            }
//        } catch (SQLException e) {
//            e.printStackTrace();
//        }


    }*/
//    public static void main(String[] args){
//        String phone = "13732259026";
//        MysqlUtil mysqlUtil = new MysqlUtil();
//        //MysqlUtil mysqlUtil = new MysqlUtil("mysqlif.ops.com","3306","tubobo_merchant","chenyl","chenyl");
////        String sql = "SELECT * from sys_message where phone = '"+phone+"' ORDER BY create_date desc";
//        String sql = "UPDATE tubobo_merchant_info set merchant_status = 'SUCCESS' WHERE user_id = '77180'";
//        int count = mysqlUtil.ExecuteSingleUpdateSQL(sql);
//        System.out.println("count="+count);
////        try {
////          if(rs.first()){
////                 String code = rs.getString("content");
////                String codeSms = code.substring(25,code.length()-2);
////                System.out.println("code="+code+"sms="+codeSms);
////            }
////        } catch (SQLException e) {
////            e.printStackTrace();
////        }
//
//
//    }

}
