package com.miya.manning.vo.conditions;

import com.miya.manning.framework.util.*;
import com.miya.manning.vo.scripts.Script;
import com.miya.manning.vo.testcase.TestCase;
import org.apache.log4j.Logger;
import org.testng.Assert;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class IFCondition implements ExcuteableCondition{
    @Override
    public boolean execute(TestCase testCase,List<Script> Scripts ,String condition, String expect, String compareType, Map... var_maps) throws Exception {
        String url_start = "https://cs2-uat.mannings.com.cn/";
        Logger logger = Logger.getLogger(IFCondition.class);
        String script_name = testCase.getScript_name();
        if(!script_name.isEmpty()){
            List<Script> execScriptList = Scripts.stream().filter(x -> x.getScript_name().equals(testCase.getScript_name())).collect(Collectors.toList());
            ToolUtil.ExecuteScript(execScriptList);
        }
        String pre_sql = testCase.getPre_sql();
        String databasename = testCase.getDatabasename();
        //1.处理前置语句,赋值给变量或者直接执行
        Map<String,String> string_var_map = var_maps[0];
        Map<String,Integer> int_var_map = var_maps[1];
        Map<String,String> res_map = var_maps[2];


        TestCaseUtil.deal_pre_sql(pre_sql, string_var_map, int_var_map, res_map , databasename);
        //用例执行部分
        //2.设置请求头
        Map<String, String> httpheadermap = new HashMap<>();
        if("C".equals(testCase.getPlatform())){
            httpheadermap  = HttpHeaderBuilt.httpHeadBuiltManningsC(string_var_map,int_var_map);
        }
        if("B".equals(testCase.getPlatform())){
            httpheadermap = HttpHeaderBuilt.httpHeadBuiltManningsB(res_map);
        }

        logger.info("以下是请求头信息:");
        for(Map.Entry<String,String> entry: httpheadermap.entrySet()){
            logger.info(entry.getKey() + ":" + entry.getValue());
        }
        //4.调用前替换params中可能存在的变量
        String params = testCase.getParams();
        logger.info("替换前的参数为:" + params);
        String new_params = ParamsBuilt.params_replace(params, int_var_map, string_var_map ,res_map);
        logger.info("替换后的参数为:" + new_params);
        //5.拼接url,调用并获取接口返回
        StringBuffer url = new StringBuffer(url_start);
        StringBuilder builder = new StringBuilder();
        url.append(testCase.getInterface_name());//先拼接一部分
        String new_url = ParamsBuilt.params_replace(url.toString(), int_var_map, string_var_map, res_map);//替换url中可能存在的变量
        StringBuffer new_url_bf = new StringBuffer(new_url);
        RequestUtil.doRequest(testCase, new_params, new_url_bf, httpheadermap, logger, builder);
        //6.收集响应信息，并按规则添加至map中
        JsonTransfer.AnalysisJson(builder.toString(),res_map);
        //7.执行检查语句,和期望值相同
        String check_sql = testCase.getCheck_sql();
        Assert.assertEquals(TestCaseUtil.do_check_sql(check_sql,string_var_map,int_var_map,res_map,databasename), true);
        //8.校验期望值
        String case_expect = testCase.getExpect();
        Assert.assertEquals(TestCaseUtil.check(expect, int_var_map,string_var_map,res_map), true);
        return true;
    }


}
